//+------------------------------------------------------------------+
//|                                          FerruFx_Multi_info+.mq4 |
//|                                        Copyright  2007, FerruFx |
//|                                                                  |
//+------------------------------------------------------------------+


#property indicator_separate_window

#property indicator_minimum 0
#property indicator_maximum 1

#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

//---- buffers
double UPBuffer[];
double DOWNBuffer[];

extern bool      AccountMini           =     true;  // If false, account is standard
extern double    LeverageToTrade       =     10.0;  // Leverage which you want to trade per position (e.g. you have a 200:1 account and you want to trade 10:1 of this leverage, just put 10)
extern double    PipValue              =    0.832;  // Pip Value

// indicators parameters
extern string    Shift_Settings_test_only        = "=== Format: 2007.05.07 00:00 ===";
extern datetime  look_time_shift       = D'2007.05.07 00:00';  // Shift for test if "test" is true
extern double    shift_indicators      =                   0;  // Shift for indicators if "test" is false
extern bool      test                  =               false;

string    MA_Settings           = "=== Moving Average Settings ===";
int       FastMAPeriod          =           20;  // Fast Moving Average period
int       MediumMAPeriod        =           50;  // Medium Moving Average period
int       SlowMAPeriod          =          100;  // Slow Moving Average period
int       MAMethod              =     MODE_EMA;  // Moving Average method
int       MAPrice               =  PRICE_CLOSE;  // Moving Average price

string    Pesky        = "=== Pesky ===";
int       PeskyPeriod          =           20;  // Pesky Period
int       PeskyMethod          =            1;  // Pesky Method


string    HeikenAshi        = "=== Heiken Ashi ===";
int       HeikenMAMethod              =            1;  // MTF Heiken Ashi method
int       HeikenMAPeriod              =           20;  // MTF Heiken Ashi period


double UP_1, UP_2, UP_3, UP_4, UP_5, UP_6, UP_7, UP_8, UP_9, UP_10;
double UP_11, UP_12, UP_13, UP_14, UP_15, UP_16, UP_17, UP_18, UP_19, UP_20;
double UP_21, UP_22, UP_23, UP_24, UP_25, UP_26, UP_27, UP_28, UP_29, UP_30;
double UP_31, UP_32, UP_33, UP_34, UP_35, UP_36, UP_37, UP_38, UP_39, UP_40;
double UP_41, UP_42, UP_43, UP_44, UP_45, UP_46, UP_47, UP_48, UP_49, UP_50;
double UP_51, UP_52, UP_53, UP_54, UP_55, UP_56, UP_57, UP_58, UP_59, UP_60;
double UP_61, UP_62, UP_63, UP_64;

double DOWN_1, DOWN_2, DOWN_3, DOWN_4, DOWN_5, DOWN_6, DOWN_7, DOWN_8, DOWN_9, DOWN_10;
double DOWN_11, DOWN_12, DOWN_13, DOWN_14, DOWN_15, DOWN_16, DOWN_17, DOWN_18, DOWN_19, DOWN_20;
double DOWN_21, DOWN_22, DOWN_23, DOWN_24, DOWN_25, DOWN_26, DOWN_27, DOWN_28, DOWN_29, DOWN_30;
double DOWN_31, DOWN_32, DOWN_33, DOWN_34, DOWN_35, DOWN_36, DOWN_37, DOWN_38, DOWN_39, DOWN_40;
double DOWN_41, DOWN_42, DOWN_43, DOWN_44, DOWN_45, DOWN_46, DOWN_47, DOWN_48, DOWN_49, DOWN_50;
double DOWN_51, DOWN_52, DOWN_53, DOWN_54, DOWN_55, DOWN_56, DOWN_57, DOWN_58, DOWN_59, DOWN_60;
double DOWN_61, DOWN_62, DOWN_63, DOWN_64;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- name for indicator window

   string short_name="   + Open Trade Analysis +";
   IndicatorShortName(short_name);

   SetIndexBuffer(0,UPBuffer);
   SetIndexBuffer(1,DOWNBuffer);

   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
  int j,total=OrdersTotal();
   for(j=0;j<total;j++)
   {
    OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
   }
   
   color color_common_line = White;
   color color_common_text = White;
   color color_connection;
   
//---- Timeframe and symbol

   string Timeframe = "";
   color color_timeframe=SkyBlue;
   
   double time_frame=Period();
   string symbol=Symbol();
   
   if(time_frame==1) { Timeframe = "M1"; }
   if(time_frame==5) { Timeframe = "M5"; }
   if(time_frame==15) { Timeframe = "M15"; }
   if(time_frame==30) { Timeframe = "M30"; }
   if(time_frame==60) { Timeframe = "H1"; }
   if(time_frame==120) { Timeframe = "H2"; }
   if(time_frame==240) { Timeframe = "H4"; }
   if(time_frame==1440) { Timeframe = "D1"; }
   if(time_frame==10080) { Timeframe = "W1"; }
   if(time_frame==43200) { Timeframe = "MN"; }
    
   ObjectCreate("timeframe", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("timeframe",symbol+"  "+Timeframe,7, "Verdana", color_timeframe);
   ObjectSet("timeframe", OBJPROP_CORNER, 0);
   ObjectSet("timeframe", OBJPROP_XDISTANCE, 35);
   ObjectSet("timeframe", OBJPROP_YDISTANCE, 17);
   
   ObjectCreate("line1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("line1","--------------------------",7, "Verdana", color_common_line);
   ObjectSet("line1", OBJPROP_CORNER, 0);
   ObjectSet("line1", OBJPROP_XDISTANCE, 2);
   ObjectSet("line1", OBJPROP_YDISTANCE, 27);
   

    
// Timeframes
 
   color color_tf = PaleGoldenrod;

   ObjectCreate("m1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m1","M1",9, "Verdana", color_tf);
   ObjectSet("m1", OBJPROP_CORNER, 0);
   ObjectSet("m1", OBJPROP_XDISTANCE, 170);
   ObjectSet("m1", OBJPROP_YDISTANCE, 21);
   
   ObjectCreate("m5", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m5","M5",9, "Verdana", color_tf);
   ObjectSet("m5", OBJPROP_CORNER, 0);
   ObjectSet("m5", OBJPROP_XDISTANCE, 170);
   ObjectSet("m5", OBJPROP_YDISTANCE, 36);
   
   ObjectCreate("m15", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m15","M15",9, "Verdana", color_tf);
   ObjectSet("m15", OBJPROP_CORNER, 0);
   ObjectSet("m15", OBJPROP_XDISTANCE, 170);
   ObjectSet("m15", OBJPROP_YDISTANCE, 51);
   
   ObjectCreate("m30", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("m30","M30",9, "Verdana", color_tf);
   ObjectSet("m30", OBJPROP_CORNER, 0);
   ObjectSet("m30", OBJPROP_XDISTANCE, 170);
   ObjectSet("m30", OBJPROP_YDISTANCE, 66);
   
   ObjectCreate("h1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("h1","H1",9, "Verdana", color_tf);
   ObjectSet("h1", OBJPROP_CORNER, 0);
   ObjectSet("h1", OBJPROP_XDISTANCE, 170);
   ObjectSet("h1", OBJPROP_YDISTANCE, 81);

   ObjectCreate("h2", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("h2","H2",9, "Verdana", color_tf);
   ObjectSet("h2", OBJPROP_CORNER, 0);
   ObjectSet("h2", OBJPROP_XDISTANCE, 170);
   ObjectSet("h2", OBJPROP_YDISTANCE, 96);   
   
   ObjectCreate("h4", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("h4","H4",9, "Verdana", color_tf);
   ObjectSet("h4", OBJPROP_CORNER, 0);
   ObjectSet("h4", OBJPROP_XDISTANCE, 170);
   ObjectSet("h4", OBJPROP_YDISTANCE, 111);
   
   ObjectCreate("d1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("d1","D1",9, "Verdana", color_tf);
   ObjectSet("d1", OBJPROP_CORNER, 0);
   ObjectSet("d1", OBJPROP_XDISTANCE, 170);
   ObjectSet("d1", OBJPROP_YDISTANCE, 126);
   
   ObjectCreate("w1", OBJ_LABEL, WindowFind("   + Open Trade Analysis +"), 0, 0);
   ObjectSetText("w1","W1",9, "Verdana", color_tf);
   ObjectSet("w1", OBJPROP_CORNER, 0);
   ObjectSet("w1", OBJPROP_XDISTANCE, 170);
   ObjectSet("w1", OBJPROP_YDISTANCE, 141);
   

// Shift calculation for indicators (tests only)

   double shift_1, shift_5, shift_15, shift_30, shift_60, shift_240, shift_1440, shift_10080;
   
   if( test == true )
   {
    shift_1=iBarShift(NULL,PERIOD_M1,look_time_shift,false);
    shift_5=iBarShift(NULL,PERIOD_M5,look_time_shift,false);
    shift_15=iBarShift(NULL,PERIOD_M15,look_time_shift,false);
    shift_30=iBarShift(NULL,PERIOD_M30,look_time_shift,false);
    shift_60=iBarShift(NULL,PERIOD_H1,look_time_shift,false);

    shift_240=iBarShift(NULL,PERIOD_H4,look_time_shift,false);
    shift_1440=iBarShift(NULL,PERIOD_D1,look_time_shift,false);
    shift_10080=iBarShift(NULL,PERIOD_W1,look_time_shift,false);
   }
   else
   {
    shift_1=shift_indicators;
    shift_5=shift_indicators;
    shift_15=shift_indicators;
    shift_30=shift_indicators;
    shift_60=shift_indicators;

    shift_240=shift_indicators;
    shift_1440=shift_indicators;
    shift_10080=shift_indicators;
  }
   

   


   
//Calculation of the trend

   double Trend_UP = UP_1 + UP_2 + UP_3 + UP_4 + UP_5 + UP_6 + UP_7 + UP_8 + UP_9 + UP_10
                                + UP_11 + UP_12 + UP_13 + UP_14 + UP_15 + UP_16 + UP_17 + UP_18 + UP_19 + UP_20
                                + UP_21 + UP_22 + UP_23 + UP_24 + UP_25 + UP_26 + UP_27 + UP_28 + UP_29 + UP_30
                                + UP_31 + UP_32 + UP_33 + UP_34 + UP_35 + UP_36 + UP_37 + UP_38 + UP_39 + UP_40
                                + UP_41 + UP_42 + UP_43 + UP_44 + UP_45 + UP_46 + UP_47 + UP_48 + UP_49 + UP_50
                                + UP_51 + UP_52 + UP_53 + UP_54 + UP_55 + UP_56 + UP_57 + UP_58 + UP_59 + UP_60
                                + UP_61 + UP_62 + UP_63 + UP_64;
   double Trend_DOWN = DOWN_1 + DOWN_2 + DOWN_3 + DOWN_4 + DOWN_5 + DOWN_6 + DOWN_7 + DOWN_8 + DOWN_9 + DOWN_10
                                  + DOWN_11 + DOWN_12 + DOWN_13 + DOWN_14 + DOWN_15 + DOWN_16 + DOWN_17 + DOWN_18 + DOWN_19 + DOWN_20
                                  + DOWN_21 + DOWN_22 + DOWN_23 + DOWN_24 + DOWN_25 + DOWN_26 + DOWN_27 + DOWN_28 + DOWN_29 + DOWN_30
                                  + DOWN_31 + DOWN_32 + DOWN_33 + DOWN_34 + DOWN_35 + DOWN_36 + DOWN_37 + DOWN_38 + DOWN_39 + DOWN_40
                                  + DOWN_41 + DOWN_42 + DOWN_43 + DOWN_44 + DOWN_45 + DOWN_46 + DOWN_47 + DOWN_48 + DOWN_49 + DOWN_50
                                  + DOWN_51 + DOWN_52 + DOWN_53 + DOWN_54 + DOWN_55 + DOWN_56 + DOWN_57 + DOWN_58 + DOWN_59 + DOWN_60
                                  + DOWN_61 + DOWN_62 + DOWN_63 + DOWN_64;
                                  
   UPBuffer[0] = Trend_UP;
   DOWNBuffer[0] = Trend_DOWN;
   
      
   return(0);
  }